// NodeAry.h: CNodeAry NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(NODEARY_H)
#define NODEARY_H

#pragma warning( disable : 4786 )
#ifndef for 
#define for if(0); else for
#endif

#include <iostream>
#include <cassert>

#include "ObjSet.h"

#include "ElemAry.h"

////////////////////////////////
// ̃NX`

namespace ls{
	class CVector_Blk;
}


namespace field{

////////////////////////////////
// CNodeAryNX̃C^[tF[X̒`
class CNodeAry
{
public:

	class CNodeSeg{
	public:
		CNodeSeg(const unsigned int& len, const std::string& name)
			: len(len), name(name){}
	public:
		std::string name;
		unsigned int len;

		// not need when initialize 
		unsigned int idofval_begin;
	};

public:
	CNodeAry(const unsigned int id, const unsigned int size);
	CNodeAry();
	virtual ~CNodeAry();

	bool ClearSegment();

	////////////////
	// Get\bh
	////////////////

	const std::string& Name() const { return m_str_name; }  // O
	int Size()	const { return m_Size; }  // ߓ_̐

	bool IsSegID( unsigned int id ) const;
	const std::vector<unsigned int>& GetAry_SegID() const { return this->m_aSeg.GetAry_ObjID(); }
	unsigned int GetFreeSegID() const;
	const CNodeSeg& GetSeg(unsigned int id_ns) const{			// Segment擾֐
		assert( this->m_aSeg.IsObjID(id_ns) );
		if( !m_aSeg.IsObjID(id_ns) ) throw;
		return m_aSeg.GetObj(id_ns);
	}

	// v!!!
	//		vfs쐬At@Cւ̏oɎgĂ
	bool GetValueFromNode( const unsigned int inode, const unsigned int id_ns, const unsigned int idofns, double& val) const{
		assert( inode < this->Size() );
		if( inode >= this->Size() ) return false;
		assert( m_aSeg.IsObjID(id_ns) );
		if( !m_aSeg.IsObjID(id_ns) ) return false;
		const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
		assert( idofns < ns.len );
		val = m_paValue[inode*m_DofSize+ns.idofval_begin+idofns];
		return true;
	}
	bool GetValueFromNodeSegment(int id_ns, ls::CVector_Blk& vec) const; // Segment̒lvecɑ

	////////////////
	// ύXE폜Eǉ\bh
	////////////////

	const std::vector<int> AddSegment( const std::vector< std::pair<unsigned int,CNodeSeg> >& seg_vec ); // Ȃ
	const std::vector<int> AddSegment( const std::vector< std::pair<unsigned int,CNodeSeg> >& seg_vec, const ls::CVector_Blk& val);  // xNgvalŏ
	const std::vector<int> AddSegment( const std::vector< std::pair<unsigned int,CNodeSeg> >& seg_vec, const double& val);  // lvalŏ

	bool SetValueToNodeSegment(unsigned int id_ns, const ls::CVector_Blk& vec); // SegmentvecZbg
	bool AddValueToNodeSegment(unsigned int id_ns, const ls::CVector_Blk& vec, double alpha); // Segmentalpha{ꂽvec

	// EݒɎgB
	bool SetValueToNode( const unsigned int inode, const unsigned int id_ns, const unsigned int idofns, const double val){
		assert( inode < this->Size() );
		if( inode >= this->Size() ) return false;
		assert( m_aSeg.IsObjID(id_ns) );
		if( !m_aSeg.IsObjID(id_ns) ) return false;
		const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
		assert( idofns < ns.len );
		m_paValue[inode*m_DofSize+ns.idofval_begin+idofns] = val;
		return true;
	}
	// EݒɎgB
	bool SetValueToNode(const field::CElemAry& ea, const unsigned int id_ns, const unsigned int idofns, const double val){

		assert( m_aSeg.IsObjID(id_ns) );
		if( !m_aSeg.IsObjID(id_ns) ) return false;
		const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
		assert( idofns < ns.len );

		unsigned int noel[256];
		unsigned int nnoel;
		for(unsigned int ielem=0;ielem<ea.Size();ielem++){
			ea.GetLpoel(ielem,nnoel,noel);
			for(unsigned int inoel=0;inoel<nnoel;inoel++){
				const unsigned int inode0 = noel[inoel];
				assert( inode0 < this->Size() );	
				m_paValue[inode0*m_DofSize+ns.idofval_begin+idofns] = val;
//				NA.SetValueToNode(inode0,id_ns_val,0, 1.0);
			}
		}
		return true;
	}

	bool InitializeFromFile(const std::string& file_name, long& offset);
	bool WriteToFile(const std::string& file_name, long& offset) const;

private:
	std::string m_str_name;
	int m_Size;

	CObjSet<CNodeSeg> m_aSeg;

	double* m_paValue;
	unsigned int m_DofSize;
};

}	// end namespace field

#endif // !defined(NODEARY_H)
