// Mat_Crs.h: CMat_Crs NX̃C^[tFCX
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 15/04/2007		
//////////////////////////////////////////////////////////////////////

#if !defined(PRECONDITIONER_H)
#define PRECONDITIONER_H

#include <assert.h>

namespace ls{

class CVector_Blk;
class CMatDia_BlkCrs;
class CPrecond_Blk{
public:
	virtual bool SolvePrecond(const CMatDia_BlkCrs& mat, CVector_Blk& vec) const = 0;
};

}	// end namespace 'ls'
#endif // PRECONDITIONER_H


