// ElemAry.h : CElemAry NX̃C^[tF[X
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 03/04/2007		
//////////////////////////////////////////////////////////////////////
#if !defined(ELEM_ARY_H)
#define ELEM_ARY_H

#include <string>

namespace field{

class CElemAry{

public:
	enum ELEM_TYPE{
		POINT=0, LINE=1, TRI=2, QUAD=3, TET=4, HEX=5
	};
	// vfZOg̎
	enum ELSEG_TYPE{ 
		ES_TYPE_UNKNOWN=10, ES_TYPE_CORNER=1, ES_TYPE_CENTER=0 
	};
	// vfZOg
	struct CElemSeg{
		unsigned int id;
		unsigned int id_na;
		unsigned int len;
		enum ELSEG_TYPE elseg_type;
		// not need when initialize
		unsigned int begin;
	};
public:
	// Get Type of Elements
	// vf̎ނԂ֐
	virtual ELEM_TYPE ElemType() const = 0;

	// Get Number of Elements
	// vfԂ֐
	virtual unsigned int Size() const = 0;

	// vfɑߓ_ԍԂ֐
	virtual void GetLpoel(const unsigned int& ielem, unsigned int& nlpoel, unsigned int* lpoel ) const = 0;
	
	// Make Point Surrounding Point
	// _͂ޓ_
	virtual bool MakePointSurPoint( const unsigned int& npoin,
		unsigned int* psup_ind, unsigned int& npsup, unsigned int*& psup ) const = 0;

	// Make Edge
	// ̂߂̊֐iv؂藣j
	virtual bool MakeEdge(unsigned int& nedge, unsigned int*& edge_ary) const = 0;

	// Make Boundary Element Ary	
	// ̂߂̊֐iv؂藣j
	virtual CElemAry* MakeBoundElemAry() const = 0;

	virtual int WriteToFile(       const std::string& file_name, long& offset, unsigned int id) const = 0;
};

}

#endif

